#include "config.h"
#include "random.h"
#include "randperm.h"

/* b * a^i (mod p), i = 0, 1, ... */
static INT32 a, b, p, q, r;     /* p = aq + r */
static INT32 idx;

#ifndef NDEBUG
static INT32 count = 0;
#endif

/* seed * base^i (mod p) */
void randperm_init (INT32 base, INT32 seed, INT32 prime)
{
    a = base;
    b = seed;
    p = prime;
    q = p / a;
    r = p - q * a;

    randperm_reset();
}


void randperm_reset ()
{
    assert (count == 0);
    idx = b;
}

INT32 randperm_next ()
{
    //SET_NEXT_LC(idx, a, p, q, r);
    idx = (idx * a) % p;
    assert(idx > 0);
    assert(idx < p);
#ifndef NDEBUG
    count++;
    if (count >= p-1) count = 0;
#endif
    return idx;
}

INT32 randperm_current ()
{
    return idx;
}
